// config: norepeat

#include "GetObjects.js"

function DoMoveXYZ()
{
	var objectpicker = moi.ui.createObjectPicker();
	objectpicker.allowEditPoints();
	
	if ( !GetObjects( objectpicker ) )
		return;
		
	var objects = objectpicker.objects;

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectObjectsPrompt' );
	moi.ui.hideUI( 'done' );
	moi.ui.showUI( 'BasePointPrompt' );
	moi.ui.showUI( 'BaseOptions' );
	moi.ui.endUIUpdate();
	
	var basept;

	var pointpicker = moi.ui.createPointPicker();
	while ( 1 )
	{
		if ( !pointpicker.waitForEvent() )
			return;
			
		if ( pointpicker.event == 'finished' )
		{
			basept = pointpicker.pt;
			break;
		}
			
		if ( pointpicker.event == 'BoundingBoxCenter' )
		{
			basept = objects.getHighAccuracyBoundingBox().center;
			moi.ui.addPickedPoint( basept );
			break;
		}		
	}
		
	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'BasePointPrompt' );
	moi.ui.hideUI( 'BaseOptions' );
	moi.ui.showUI( 'done' );
	moi.ui.showUI( 'TargetPointPrompt' );
	moi.ui.showUI( 'TargetOptions' );
	moi.ui.endUIUpdate();

	var movefactory = moi.command.createFactory( 'move' );
	
	movefactory.setInput( 0, objects );
	movefactory.setInput( 1, basept );

	var cplane = moi.view.getCPlane();
	moi.ui.commandUI.x.value = cplane.distancex( basept );
	moi.ui.commandUI.y.value = cplane.distancey( basept );
	moi.ui.commandUI.z.value = cplane.distancez( basept );
	
	var dlg = moi.ui.commandDialog;

	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
			return false;
			
		if ( dlg.event == 'done' )
			break;

		if ( dlg.event == 'x' || dlg.event == 'y' || dlg.event == 'z' )
		{
			var pt = moi.vectorMath.createPoint( moi.ui.commandUI.x.value, moi.ui.commandUI.y.value, moi.ui.commandUI.z.value );
			pt = moi.view.getCPlane().evaluate( pt.x, pt.y, pt.z );
			movefactory.setInput( 2, pt );
			movefactory.update();
		}
	}
		
	movefactory.commit();
}

DoMoveXYZ();
